//     - 2013
// :  
// :  

#include <cstdio>
#include <iostream>

using namespace std;

const int N = 4;
const int M = 5;
const int X[] = {1, 2, 2, 1, -1, -2, -2, -1};
const int Y[] = {2, 1, -1, -2, -2, -1, 1, 2};

int chess[N][M],
	totalAnswers = 0;

bool CheckCord(int row, int col)
{
	return (row >= 0 && row < N && col >= 0 && col < M);
}

void PrintChessInline()
{
	for (int row = 0; row < N - 1; row++)
	{
		for (int col = 0; col < M; col++)
		{
			printf("%d ", chess[row][col]);
		}
	}
	for (int col = 0; col < M - 1; col++)
	{
		printf("%d ", chess[N - 1][col]);
	}
	printf("%d\n", chess[N - 1][M - 1]);
}

void NextMove(int row, int col)
{
	if (chess[row][col] == N * M)
	{
		PrintChessInline();
		totalAnswers++;
		return;
	}
	
	for (int i = 0; i < 8; i++)
	{
		int x = row + X[i],
			y = col + Y[i];
		
		if (CheckCord(x, y) && !chess[x][y])
		{
			chess[x][y] = chess[row][col] + 1;
			NextMove(x, y);
			chess[x][y] = 0;
		}
	}
}

int main()
{
	for (int row = 0; row < N; row++)
	{
		for (int col = 0; col < M; col++)
		{
			chess[row][col] = 1;
			NextMove(row, col);
			chess[row][col] = 0;
		}
	}
	printf("%d\n", totalAnswers);
	return 0;
}
